/**
 * 文件名称：DateTimePickerDialog.java
 * 版权声明：版权所有 (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 * 许可证声明：根据Apache License, Version 2.0（“许可证”）获得许可；
 * 除非遵守许可证，否则不得使用此文件。
 * 您可以在以下网址获得许可证的副本：
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * 除非适用法律要求或书面同意，否则按“现状”分发的软件是在没有任何明示或暗示的
 * 保证和条件的情况下提供的，包括但不限于关于所有权、不侵犯第三方权利、适销性或
 * 适用于特定用途的任何保证和条件。有关权限和限制的具体语言，请参见许可证。
 */

package net.micode.notes.ui; // 定义包名

import java.util.Calendar; // 导入日历类

import net.micode.notes.R; // 导入资源文件R，用于访问资源
import net.micode.notes.ui.DateTimePicker; // 导入DateTimePicker类
import net.micode.notes.ui.DateTimePicker.OnDateTimeChangedListener; // 导入DateTimePicker的监听器接口

import android.app.AlertDialog; // 导入AlertDialog类，用于创建对话框
import android.content.Context; // 导入Context类
import android.content.DialogInterface; // 导入DialogInterface类
import android.content.DialogInterface.OnClickListener; // 导入点击事件监听器接口
import android.text.format.DateFormat; // 导入日期格式化类
import android.text.format.DateUtils; // 导入日期工具类

/**
 * DateTimePickerDialog 类是一个继承自AlertDialog的对话框，用于选择日期和时间。
 */
public class DateTimePickerDialog extends AlertDialog implements OnClickListener {

    // 成员变量
    private Calendar mDate = Calendar.getInstance(); // 当前日期时间的Calendar实例
    private boolean mIs24HourView; // 是否使用24小时制
    private OnDateTimeSetListener mOnDateTimeSetListener; // 日期时间设置监听器
    private DateTimePicker mDateTimePicker; // DateTimePicker组件

    /**
     * 日期时间设置监听器接口
     */
    public interface OnDateTimeSetListener {
        void OnDateTimeSet(AlertDialog dialog, long date); // 当日期时间设置时的回调方法
    }

    /**
     * DateTimePickerDialog构造函数
     * @param context 上下文环境
     * @param date 初始日期时间的毫秒值
     */
    public DateTimePickerDialog(Context context, long date) {
        super(context); // 调用AlertDialog的构造函数
        mDateTimePicker = new DateTimePicker(context); // 创建DateTimePicker实例
        setView(mDateTimePicker); // 设置对话框的内容视图
        // 设置日期时间改变监听器
        mDateTimePicker.setOnDateTimeChangedListener(new OnDateTimeChangedListener() {
            public void onDateTimeChanged(DateTimePicker view, int year, int month,
                    int dayOfMonth, int hourOfDay, int minute) {
                mDate.set(Calendar.YEAR, year); // 设置年
                mDate.set(Calendar.MONTH, month); // 设置月
                mDate.set(Calendar.DAY_OF_MONTH, dayOfMonth); // 设置日
                mDate.set(Calendar.HOUR_OF_DAY, hourOfDay); // 设置小时
                mDate.set(Calendar.MINUTE, minute); // 设置分钟
                updateTitle(mDate.getTimeInMillis()); // 更新对话框标题
            }
        });
        mDate.setTimeInMillis(date); // 设置初始日期时间
        mDate.set(Calendar.SECOND, 0); // 设置秒为0
        mDateTimePicker.setCurrentDate(mDate.getTimeInMillis()); // 设置DateTimePicker的初始日期时间
        // 设置对话框按钮
        setButton(context.getString(R.string.datetime_dialog_ok), this);
        setButton2(context.getString(R.string.datetime_dialog_cancel), (OnClickListener)null);
        // 设置24小时制视图
        set24HourView(DateFormat.is24HourFormat(this.getContext()));
        updateTitle(mDate.getTimeInMillis()); // 更新对话框标题
    }

    /**
     * 设置是否使用24小时制视图
     * @param is24HourView 是否使用24小时制
     */
    public void set24HourView(boolean is24HourView) {
        mIs24HourView = is24HourView;
        // 根据是否使用24小时制更新DateTimePicker
        mDateTimePicker.set24HourView(is24HourView);
    }

    /**
     * 设置日期时间设置监听器
     * @param callBack 监听器实例
     */
    public void setOnDateTimeSetListener(OnDateTimeSetListener callBack) {
        mOnDateTimeSetListener = callBack; // 设置监听器
    }

    /**
     * 更新对话框标题
     * @param date 毫秒值表示的日期时间
     */
    private void updateTitle(long date) {
        int flag = DateUtils.FORMAT_SHOW_YEAR | DateUtils.FORMAT_SHOW_DATE | DateUtils.FORMAT_SHOW_TIME;
        // 根据是否使用24小时制设置格式化标志
        flag |= mIs24HourView ? DateUtils.FORMAT_24HOUR : DateUtils.FORMAT_12HOUR;
        // 设置对话框标题为日期时间字符串
        setTitle(DateUtils.formatDateTime(this.getContext(), date, flag));
    }

    /**
     * 点击事件处理
     * @param arg0 对话框接口
     * @param arg1 按钮标识
     */
    public void onClick(DialogInterface arg0, int arg1) {
        // 如果设置了监听器，则回调监听器
        if (mOnDateTimeSetListener != null) {
            mOnDateTimeSetListener.OnDateTimeSet(this, mDate.getTimeInMillis());
        }
    }

}